package com.circuitengine.model.Components;

import java.awt.Graphics;

import com.circuitengine.model.TiePoint;

/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class Battery extends ElectricComponent {
  double voltage;
  public Battery(int x, int y){
    super(x,y);
    init();
  }
  public void init(){
    primary="Voltage";
    primaryUnit="Volt";
    primaryUnitPlural="Volts";
    primarySymbol="V";
    primaryUnitSymbol="V";
    preselectedPrimaryPrefix="V";
  }
  public void draw(Graphics g) {
    super.draw(g);
    int x1=head.getX();
    int x2=tail.getX();
    int y1=head.getY();
    int y2=tail.getY();
    int rise = y2 - y1;
    int run = x2 - x1;
    int distanceSquared = (rise * rise + run * run);
    double divisor;
    divisor = Math.sqrt(distanceSquared) / 16.0;
    if (distanceSquared < 16 * 16) {
        divisor = 1.0;
    }
    double middlex1 = x1 + run / 2.0 - run / 4.0 / divisor;
    double middley1 = y1 + rise / 2.0 - rise / 4.0 / divisor;
    double middlex2 = x2 - run / 2.0 + run / 4.0 / divisor;
    double middley2 = y2 - rise / 2.0 + rise / 4.0 / divisor;
    g.drawLine(x1, y1, (int) middlex1, (int) middley1);
    g.drawLine((int) middlex2, (int) middley2, x2, y2);
    g.drawLine((int) (middlex1 - rise / divisor), (int) (middley1 + run / divisor), (int) (middlex1 + rise / divisor),
               (int) (middley1 - run / divisor));
    g.drawLine((int) (middlex2 - rise / divisor / 2), (int) (middley2 + run / divisor / 2),
               (int) (middlex2 + rise / divisor / 2), (int) (middley2 - run / divisor / 2));
  }
}
